#ifndef __KEY_RECORDER_H__
#define __KEY_RECORDER_H__

#include <vector>
#include <string>
#include <stdint.h>
#include <cstdlib>
#include "GameControls.h"
#include <ngl/Vector.h>

class KeyRecorder
{
	public :
		KeyRecorder();
		~KeyRecorder();
		void load(
							 const std::string &_fname
						 );
		void save(
							const std::string &_fname
						 );
		size_t size();
		uint8_t operator[](
												size_t i
											);
		void addFrame(
									 uint8_t _controlVars
									);
		inline void setStartPosition(
																const ngl::Vector &_pos
															)
															{
																m_startPos=_pos;
															}
		inline ngl::Vector getStartPosition() const
																			{
																			  return m_startPos;
																			}
private :

		std::vector<uint8_t> m_replayFrames;
		/// @brief the start position
		ngl::Vector m_startPos;

};

#endif
